package com.uas.util;

import org.apache.commons.io.FileUtils;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.springframework.web.multipart.MultipartFile;

import java.io.*;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.*;

import static com.uas.util.BaseUtil.getInsertSqlbyMaps;

/**
 * @author koul
 *
 */
public class FileUtil {
    /**
     * 生成文件实际存放的硬盘唯一路径
     *
     * @param fileName
     * @return
     */
    private static String getFilePath(String fileName, String em_code) {
        String uuid = UUID.randomUUID().toString().replaceAll("\\-", "");
        String suffix = fileName.indexOf(".") != -1 ? fileName.substring(fileName.lastIndexOf("."), fileName.length()) : "";
        String path = "/usr/local/uas/tomcat/webapps/postattach";
        File file = new File(path);
        if (!file.isDirectory()) {
            file.mkdir();
            path = path + File.separator + em_code;
            new File(path).mkdir();
        } else {
            path = path + File.separator + em_code;
            file = new File(path);
            if (!file.isDirectory()) {
                file.mkdir();
            }
        }
        return path + File.separator + uuid + suffix;
    }
    /**
     * 上传到本地磁盘
     *
     * @return
     */
    private static String uploadToLocal(MultipartFile file, String em_code) {
        String path =getFilePath(file.getOriginalFilename(), em_code);
        try {
            FileUtils.copyInputStreamToFile(file.getInputStream(), new File(path));
            return path;
        } catch (IOException e1) {
            e1.printStackTrace();
        }
        return null;
    }

    /**
     * 保存文件
     *
     * <pre>
     * 优先判断是否设置了指定的文件系统，否则保存到本地
     * </pre>
     *
     * @param file
     * @return
     */
    public static String saveFile(MultipartFile file, String em_code) {
        String path = uploadToLocal(file, em_code);
        if(path.contains("\\")){//上传到本地返回路径修改
            path=path.replace("\\", "/");
        }
        return path;
    }
    /**
     * 上传文件都服务器
     * @param statement
     * @param file
     * @param sob
     * @return
     */
	public static Boolean fileUp(Statement statement, MultipartFile file, String sob){
		boolean result = false;
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String filename = file.getOriginalFilename().replaceAll(",", "，");
        String originalFilename = file.getOriginalFilename();
		int size = (int) file.getSize();
        if(size>0) {
			try {
                ResultSet set = statement.executeQuery("select count(1) from " + sob + ".FTPATTCHTEMP where FT_FILENAME='" + filename + "' and FT_SOB='"+sob+"'");
                while (set.next()){
                    int count = set.getInt(1);
                    if (count==0){
                        String path = saveFile(file, "FTP");
                        ResultSet resultSet = statement.executeQuery("select " + sob + ".EMAILFILEPATH.nextval from dual");
                        if (resultSet.next()) {
                            int id = resultSet.getInt(1);
                            String sql1 =
                                    "INSERT INTO " + sob + ".filepath(fp_id,fp_path,fp_size,fp_man,fp_date,fp_name) values(" + id + ",'" + path +
                                            "'," + size + ",'" + "FTP" + "'," + "to_date('" + format.format(new Date()) + "','yyyy-mm-dd HH24:mi:ss')" + ",'" + filename + "')";
                            int i = statement.executeUpdate(sql1);
                            if (i > 0) {
                                String substring = null;
                                if (filename.indexOf("-") != -1) {
                                    substring = filename.substring(0, filename.indexOf("-"));
                                } else {
                                    substring = filename.substring(0, filename.indexOf("."));
                                }
                                String sql3 = "INSERT INTO " + sob + ".FTPATTCHTEMP(FT_ID,FT_ATTCH,FT_PIINOUTNO,FT_STATUS,FT_INSERTDATE,FT_FILENAME,FT_SOB)values(" + sob + ".FTPATTCHTEMP_SEQ.nextval,'" + id + ";','" + substring + "','GET',to_date('" + format.format(new Date()) + "','yyyy-mm-dd HH24:mi:ss')" + ",'" + filename + "','" + sob + "')";
                                int i1 = statement.executeUpdate(sql3);
                                if (i1 > 0) {
                                    result = true;
                                }
                            }
                        }
                        statement.close();
                    }
                }
                result=true;
            } catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return result;
	}

    /**
     * 解析xml文件，生成数据
     * @param file xml文件
     * @return
     */
    @SuppressWarnings("unchecked")
    public static boolean getDataAndSqlByXml(Connection con , File file,String sob){
        boolean bool = false;
        List<String> sqls = new ArrayList<String>();
        InputStream in = null;
        try {
            in = new FileInputStream(file);
        } catch (FileNotFoundException e1) {
            e1.printStackTrace();
        }
        SAXReader reader = new SAXReader();
        Document doc = null;
        try {
            doc = reader.read(in);
            in.close();
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        Element root = doc.getRootElement();
        List<Element> e = root.elements();
        List<Map<String, Object>> maps = new ArrayList<>();
        Object DocumentDateTime =null;
        Object DocumentNumber = null;
        for(Element el:e){
            String name = el.getName();
            if(name=="Header"){
                List<Element> elements = el.elements();
                for (Element ee:elements) {
                    String name1 = ee.getName();
                    if(name1=="DocumentNumber"){
                        DocumentNumber=ee.getData();
                    }else if(name1=="DocumentDateTime"){
                        DocumentDateTime=ee.getData();
                    }
                }
            }else if(name=="Detail"){
                List<Element> elements = el.elements();
                for (Element ee:elements) {
                    List<Element> elements1 = ee.elements();
                    String name1 = ee.getName();
                    if (name1=="Item") {
                        Map<String, Object> detailMap = new HashMap<>();
                        for (Element eel : elements1) {
                            String name2 = eel.getName();
                            if (name2 == "LineNo") {
                                detailMap.put("sq_lineno",eel.getData());
                            } else if (name2 == "WhouseCode") {
                                detailMap.put("sq_whousecode",eel.getData());
                            } else if (name2 == "WhouseName") {
                                detailMap.put("sq_whousename",eel.getData());
                            } else if (name2 == "ProdCode") {
                                detailMap.put("sq_prodcode",eel.getData());
                            } else if (name2 == "PrDetail") {
                                detailMap.put("sq_prdetail",eel.getData());
                            } else if (name2 == "Spec") {
                                detailMap.put("sq_spec",eel.getData());
                            } else if (name2 == "Brand") {
                                detailMap.put("sq_brand",eel.getData());
                            } else if (name2 == "StcockQty") {
                                detailMap.put("sq_stcockqty",eel.getData());
                            } else if (name2 == "Unit") {
                                detailMap.put("sq_unit",eel.getData());
                            }

                        }
                        detailMap.put("sq_code",DocumentNumber);
                        detailMap.put("sq_date",BaseUtil.date2String(BaseUtil.string2Date(DocumentDateTime.toString()
                                ,"yyyyMMddHHmm"),""));
                        detailMap.put("sq_indate",BaseUtil.date2String(new Date(),""));
                        detailMap.put("sq_baqty","(select nvl(sum(nvl(ba_remain,0)),0) from batch where " +
                                "ba_prodcode='"+detailMap.get("sq_prodcode")+"' and ba_whcode='"+detailMap.get("sq_whousecode")+"')@N");
                        maps.add(detailMap);
                    }
                }
            }
        }
        if (maps!=null&&maps.size()>0){
            sqls = getInsertSqlbyMaps(maps, sob+".StcockQty","sq_id",sob+".STCOCKQTY_SEQ.nextval");
            bool = JdbcUtil.executeSqls(con, sqls);
        }
        return bool;
    }
}
